/*============================================================================
//	apci8131s.c
//
//	aPCI-8131
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci8131w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR sz8131[]  = _T("aPCI-8131");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	APCI8131RESOURCE Ri;		/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				/* ۰ذ̒l */
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// apci8131.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci8131wDllOpen() == FALSE){
		ErrorMessage(APCI8131_SLOT_AUTO);
		return 1;				/* apci8131.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-8131 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci8131wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI8131_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL    Version\t: %08lxh\n")
					_T("Driver Version\t: %08lxh"),
					dwDLLVer,
					dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8131̎gp錾
	//-----------------------------------------------*/
	wLogSlot = APCI8131_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Apci8131wCreate(&wLogSlot);	/* ꍇA̎޲̘_ۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(APCI8131_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("aPCI-8131 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-----------------------------------------------*/
	if (Apci8131wGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci8131wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Board Name  \t: %s\n")
					_T("IO Address  \t: %04Xh-%04Xh\n")
					_T("EICR Address\t: %04Xh-%04Xh\n")
					_T("Switch      \t: %02X\n"),
					sz8131,
					Ri.dwIOPortBase[1],
					Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
					Ri.dwIOPortBase[0],
					Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1,
					dwSwVal);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ɔCӂްo
	//-----------------------------------------------*/
	cbDat = (BYTE)0xAA;
	if (Apci8131wOutPort(wLogSlot, APCI8131_PORT_1, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 փf[^o\n")
					_T("Port 1 Out Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Apci8131wInPort(wLogSlot, APCI8131_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 f[^\n")
					_T("Port 1 In Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-8131̎gpJ
	//-----------------------------------------------*/
	if (Apci8131wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-8131 Closed"));
	/*-------------------------------------------------
	// apci8131.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci8131wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci8131wGetLastError(wLogSlot);
	TCHAR szBuf[50];

	switch (dwRes){
		case APCI8131_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;
		case APCI8131_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("aPCI-8131 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
