/*============================================================================
//	apci8131w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci8131w.h"	/* aPCI-8131 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci8131wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci8131GetVersion = NULL;
static FARPROC pApci8131Create = NULL;
static FARPROC pApci8131Close = NULL;
static FARPROC pApci8131GetResource = NULL;
static FARPROC pApci8131InPort = NULL;
static FARPROC pApci8131OutPort = NULL;
static FARPROC pApci8131GetLastError = NULL;
static FARPROC pApci8131GetSwitchValue = NULL;

/*============================================================================
// 	  apci8131.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI8131_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci8131wGetDllExportFunc();
			if (TRUE != Result)
				Apci8131wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci8131.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aPCI-8131 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aPCI-8131̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131Create)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aPCI-8131̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131Close)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wGetResource(WORD wLogSlot, PAPCI8131R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131GetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131InPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131OutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
/*============================================================================
// 	  aPCI-8131̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci8131wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI8131_ERR_WRAPDLL;
	else
		return (*pApci8131GetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 	      pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci8131wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8131GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci8131wGetDllExportFunc()
{
	/* Apci8131GetVersion ̱ڽ擾 */
	pApci8131GetVersion = GetProcAddress(hDLL, _T("Apci8131GetVersion"));
	if (pApci8131GetVersion == NULL)
		return FALSE;

	/* Apci8131Create ̱ڽ擾 */
	pApci8131Create = GetProcAddress(hDLL, _T("Apci8131Create"));
	if (pApci8131Create == NULL)
		return FALSE;

	/* Apci8131Close ̱ڽ擾 */
	pApci8131Close = GetProcAddress(hDLL, _T("Apci8131Close"));
	if (pApci8131Close == NULL)
		return FALSE;

	/* Apci8131GetResource ̱ڽ擾 */
	pApci8131GetResource = GetProcAddress(hDLL, _T("Apci8131GetResource"));
	if (pApci8131GetResource == NULL)
		return FALSE;

	/* Apci8131InPort ̱ڽ擾 */
	pApci8131InPort = GetProcAddress(hDLL, _T("Apci8131InPort"));
	if (pApci8131InPort == NULL)
		return FALSE;

	/* Apci8131OutPort ̱ڽ擾 */
	pApci8131OutPort = GetProcAddress(hDLL, _T("Apci8131OutPort"));
	if (pApci8131OutPort == NULL)
		return FALSE;

	/* Apci8131GetLastError ̱ڽ擾 */
	pApci8131GetLastError = GetProcAddress(hDLL, _T("Apci8131GetLastError"));
	if (pApci8131GetLastError == NULL)
		return FALSE;

	/* Apci8131GetSwitchValue ̱ڽ擾 */
	pApci8131GetSwitchValue = GetProcAddress(hDLL, _T("Apci8131GetSwitchValue"));
	if (pApci8131GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
